# coding: utf-8
import uuid, base64
from django.http import HttpResponseRedirect
from django.shortcuts import render_to_response
from django.http import HttpResponse
from django import newforms as forms
from google.appengine.api import users, images
from google.appengine.ext import db
from settings import STATIC_PATH
from shop.util import err_page
from shop.model import coffeeuser

def login(req):
    user_info = users.get_current_user()
    if not user_info:
        return HttpResponseRedirect(users.create_login_url('/user/login/'))
    
    try:
        u = coffeeuser.CoffeeUser.all().filter('user =', user_info).get()
        if u:
            return HttpResponseRedirect('/')
        else:
            api_key = ''
            while not api_key[0:1].isalnum():
                uid = uuid.uuid4()
                api_key = base64.b64encode(uid.bytes)
                api_key = api_key[0:22]
        
        u = coffeeuser.CoffeeUser(user = user_info, email = user_info.email(), nickname = user_info.nickname(), api_key = api_key)
        u.put()
        return HttpResponseRedirect('/user')
    except Exception, x:
        return err_page(_('Login Error'))
    
class UserInfoForm(forms.Form):
    real_name = forms.CharField(label=_('Real Name'), required=False, widget=forms.TextInput(attrs={'size':'20'}))
    phone = forms.CharField(label=_('Phone'), required=False, widget=forms.TextInput(attrs={'size':'20'}))
    address = forms.CharField(label=_('Address'), required=False, widget=forms.TextInput(attrs={'size':'20'}))
    photo_file = forms.CharField(label=_('Photo'), required=False, widget=forms.FileInput)
    
    
def index(req):
    user_info = users.get_current_user()
    if not user_info:
        return HttpResponseRedirect('/user/login')
    
    if req.method == 'GET':
        u = coffeeuser.CoffeeUser.all().filter('user =', user_info).get()
        f_data = {'real_name' : u.realname, 'phone' : u.phone, 'address' : u.address}
        u_form = UserInfoForm(f_data)
        context = {'static_path' : STATIC_PATH,
                   'user' : u,
                   'user_info' : user_info,
                   'form' : u_form
                   }
        return render_to_response('user_modify.html', context)
    if req.method == 'POST':
        try : 
            u_form = UserInfoForm(req.POST)
            if not u_form.is_valid():
                return err_page(_('Error'))
            
            u = coffeeuser.CoffeeUser.all().filter('user =', user_info).get()
            u.nickname = user_info.nickname()
            u.realname = req.POST.get('real_name')
            u.phone = req.POST.get('phone')
            u.address = req.POST.get('address')
            if req.FILES.get('photo_file'):
                file = req.FILES.get('photo_file')
                img = images.Image(file['content'])
                img.resize(width=150, height=150)
                resize_img = img.execute_transforms(output_encoding=images.JPEG)
                u.photo_file = db.Blob(resize_img)
            u.put()
            return HttpResponseRedirect('/user/')
        except Exception, x:
            return err_page(_('Index Error'))
        
def photo(req):
    user_info = users.get_current_user()
    if not user_info:
        return HttpResponseRedirect('/user/login/')
    
    u = coffeeuser.CoffeeUser.all().filter('user =', user_info).get()
    resp = HttpResponse()
    if u.photo_file != None:
        resp.headers['Content-Type'] = 'image/jpeg'
        resp.content = u.photo_file
        return resp
    else:
        return resp