import os, sys
import unittest

def SetTestEnv():
    os.environ['DJANGO_SETTING_MODULE'] = 'settings'
    GAE_PATH = 'c:\\Program Files\\Google\\google_appengine'
    
    EXTRA_PATHS = [
        GAE_PATH,
        os.path.join(GAE_PATH, 'lib', 'antlr3'),
        os.path.join(GAE_PATH, 'lib', 'django'),
        os.path.join(GAE_PATH, 'lib', 'webob'),
        os.path.join(GAE_PATH, 'lib', 'yaml', 'lib'),
    ]
    sys.path = sys.path + EXTRA_PATHS
    
if __name__ == '__main__':
    SetTestEnv()
    print '============'
    print os.path.realpath(__file__)
    print os.path.dirname(os.path.realpath(__file__))
    print os.path.abspath(os.path.dirname(os.path.realpath(__file__)))
    print os.path.join(os.path.abspath(os.path.dirname(os.path.realpath(__file__))))
    file_list = os.listdir(os.path.abspath(os.path.dirname(os.path.realpath(__file__))))
    print '============'
    print file_list
    test_modules = []
    for file_name in file_list:
        extension = os.path.splitext(file_name)[-1]
    if extension == '.py':
        test_module_name = "tests." + os.path.splitext(file_name)[0:-1][0]
        module = __import__(test_module_name, globals(), locals(), test_module_name)
        test_modules.append(module)
    
    suite = unittest.TestSuite(map(unittest.defaultTestLoader.loadTestsFromModule, test_modules))
    runner = unittest.TextTestRunner()
    runner.run(suite)